# Generated by Django 3.0.9 on 2021-03-23 17:08

from django.conf import settings
import django.contrib.postgres.fields
import django.contrib.postgres.fields.jsonb
import django.contrib.postgres.indexes
from django.db import migrations, models
import django.db.models.deletion
import lofar.sas.tmss.tmss.tmssapp.models.specification


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Algorithm',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='AntennaSet',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('rcus', django.contrib.postgres.fields.ArrayField(base_field=models.IntegerField(), size=128)),
                ('inputs', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, size=128)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Cluster',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('location', models.CharField(help_text='Human-readable location of the cluster.', max_length=128)),
                ('archive_site', models.BooleanField(default=False, help_text='TRUE if this cluster is an archive site, FALSE if not (f.e. a local cluster, or user-owned cluster).')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='CommonSchemaTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='CopyReason',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Cycle',
            fields=[
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128, primary_key=True, serialize=False)),
                ('start', models.DateTimeField(help_text='Moment at which the cycle starts, that is, when its projects can run.')),
                ('stop', models.DateTimeField(help_text='Moment at which the cycle officially ends.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='CycleQuota',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.FloatField(help_text='Resource Quota value')),
            ],
        ),
        migrations.CreateModel(
            name='Dataformat',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Dataproduct',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('filename', models.CharField(help_text='Name of the file (or top-level directory) of the dataproduct. Adheres to a naming convention, but is not meant for parsing.', max_length=128)),
                ('directory', models.CharField(help_text='Directory where this dataproduct is (to be) stored.', max_length=1024)),
                ('deleted_since', models.DateTimeField(help_text='When this dataproduct was removed from disk, or NULL if not deleted (NULLable).', null=True)),
                ('specifications_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Dataproduct properties (f.e. beam, subband), to distinguish them when produced by the same task, and to act as input for selections in the Task Input and Work Request Relation Blueprint objects.')),
                ('do_cancel', models.DateTimeField(help_text='When this dataproduct was cancelled (NULLable).  Cancelling a dataproduct triggers cleanup if necessary.', null=True)),
                ('expected_size', models.BigIntegerField(help_text='Expected size of dataproduct size, in bytes. Used for scheduling purposes. NULL if size is unknown (NULLable).', null=True)),
                ('size', models.BigIntegerField(help_text='Dataproduct size, in bytes. Used for accounting purposes. NULL if size is (yet) unknown (NULLable).', null=True)),
                ('feedback_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Dataproduct properties, as reported by the producing process.')),
            ],
        ),
        migrations.CreateModel(
            name='DataproductArchiveInfo',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('storage_ticket', models.CharField(help_text='Archive-system identifier.', max_length=128)),
                ('public_since', models.DateTimeField(help_text='Dataproduct is available for public download since this moment, or NULL if dataproduct is not (NULLable).', null=True)),
                ('corrupted_since', models.DateTimeField(help_text='Earliest timestamp from which this dataproduct is known to be partially or fully corrupt, or NULL if dataproduct is not known to be corrupt (NULLable).', null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DataproductFeedbackTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DataproductHash',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('hash', models.CharField(help_text='Hash value.', max_length=128)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DataproductSpecificationsTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DataproductTransform',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('identity', models.BooleanField(help_text='TRUE if this transform only copies, tars, or losslessly compresses its input, FALSE if the transform changes the data. Allows for efficient reasoning about data duplication.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Datatype',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultDataproductSpecificationsTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultGeneratorTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultReservationTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultSchedulingConstraintsTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultSchedulingUnitTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultSubtaskTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultTaskRelationSelectionTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DefaultTaskTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(max_length=128, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Filesystem',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('capacity', models.BigIntegerField(help_text='Capacity in bytes')),
                ('directory', models.CharField(help_text='Root directory under which we are allowed to write our data.', max_length=1024)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Flag',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='GeneratorTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
                ('create_function', models.CharField(help_text='Python function to call to execute the generator.', max_length=128)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='IOType',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='PeriodCategory',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128, primary_key=True, serialize=False)),
                ('priority_rank', models.FloatField(help_text='Priority of this project w.r.t. other projects. Projects can interrupt observations of lower-priority projects.')),
                ('trigger_priority', models.IntegerField(default=1000, help_text='Priority of this project w.r.t. triggers.')),
                ('auto_ingest', models.BooleanField(default=False, help_text='True if The data is ingested when the other scheduling unit tasks are finished. False if The data is ingested after approval in the QA validation workflow. At the end of this a flag is set that the data can be ingested.')),
                ('can_trigger', models.BooleanField(default=False, help_text='True if this project is allowed to supply observation requests on the fly, possibly interrupting currently running observations (responsive telescope).')),
                ('private_data', models.BooleanField(default=True, help_text='True if data of this project is sensitive. Sensitive data is not made public.')),
                ('expert', models.BooleanField(default=False, help_text='Expert projects put more responsibility on the PI.')),
                ('filler', models.BooleanField(default=False, help_text='Use this project to fill up idle telescope time.')),
                ('auto_pin', models.BooleanField(default=False, help_text='True if the output_pinned flag of tasks in this project should be set True on creation.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ProjectCategory',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ProjectPermission',
            fields=[
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128, primary_key=True, serialize=False)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ProjectQuota',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.FloatField(help_text='Resource Quota value')),
            ],
        ),
        migrations.CreateModel(
            name='ProjectQuotaArchiveLocation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
        ),
        migrations.CreateModel(
            name='ProjectRole',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Quantity',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Reservation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(help_text='Short description for this reservation, used in overviews', max_length=255)),
                ('start_time', models.DateTimeField(help_text='Start of this reservation.')),
                ('stop_time', models.DateTimeField(help_text='Stop of this reservation. If null, then this reservation is indefinitely.', null=True)),
                ('specifications_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Properties of this reservation')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ReservationStrategyTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.CharField(help_text='Version of this template (with respect to other templates of the same name).', max_length=128)),
                ('template', django.contrib.postgres.fields.jsonb.JSONField(help_text='JSON-data compliant with the JSON-schema in the reservation_template. This reservation strategy template like a predefined recipe with all the correct settings, and defines which parameters the user can alter.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ReservationTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ResourceType',
            fields=[
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128, primary_key=True, serialize=False)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Role',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SAP',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('specifications_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='SAP properties.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SAPTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingConstraintsTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingRelationPlacement',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingSet',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('generator_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Parameters for the generator (NULLable).', null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingUnitBlueprint',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('requirements_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Scheduling and/or quality requirements for this scheduling unit (IMMUTABLE).')),
                ('do_cancel', models.BooleanField()),
                ('ingest_permission_required', models.BooleanField(default=False, help_text='Explicit permission is needed before the task.')),
                ('ingest_permission_granted_since', models.DateTimeField(help_text='The moment when ingest permission was granted.', null=True)),
                ('output_data_allowed_to_be_ingested', models.BooleanField(default=False, help_text='boolean (default FALSE), which blocks Ingest Tasks from starting if OFF. When toggled ON, backend must scan for startable Ingest Tasks.')),
                ('output_pinned', models.BooleanField(default=False, help_text='boolean (default FALSE), which blocks deleting unpinned dataproducts. When toggled ON, backend must pick SUB up for deletion. It also must when dataproducts are unpinned.')),
                ('results_accepted', models.BooleanField(default=False, help_text='boolean (default NULL), which records whether the results were accepted, allowing the higher-level accounting to be adjusted.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingUnitDraft',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('requirements_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Scheduling and/or quality requirements for this run.')),
                ('generator_instance_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Parameter value that generated this run draft (NULLable).', null=True)),
                ('scheduling_constraints_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Scheduling Constraints for this run.', null=True)),
                ('ingest_permission_required', models.BooleanField(default=False, help_text='Explicit permission is needed before the task.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingUnitObservingStrategyTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.CharField(help_text='Version of this template (with respect to other templates of the same name).', max_length=128)),
                ('template', django.contrib.postgres.fields.jsonb.JSONField(help_text='JSON-data compliant with the JSON-schema in the scheduling_unit_template. This observation strategy template like a predefined recipe with all the correct settings, and defines which parameters the user can alter.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SchedulingUnitTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SIPidentifier',
            fields=[
                ('source', models.CharField(help_text='Source name', max_length=128)),
                ('unique_identifier', models.BigAutoField(help_text='Unique global identifier.', primary_key=True, serialize=False)),
            ],
        ),
        migrations.CreateModel(
            name='StationType',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Subtask',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('start_time', models.DateTimeField(help_text='Start this subtask at the specified time (NULLable).', null=True)),
                ('stop_time', models.DateTimeField(help_text='Stop this subtask at the specified time (NULLable).', null=True)),
                ('specifications_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Final specifications, as input for the controller.')),
                ('do_cancel', models.DateTimeField(help_text='Timestamp when the subtask has been ordered to cancel (NULLable).', null=True)),
                ('raw_feedback', models.CharField(help_text='The raw feedback for this Subtask', max_length=1048576, null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubtaskInput',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('selection_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Filter to apply to the dataproducts of the producer, to derive input dataproducts when scheduling.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubtaskOutput',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubtaskState',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubtaskStateLog',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('user_identifier', models.CharField(editable=False, help_text='The ID of the user who changed the state of the subtask.', max_length=128, null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubtaskTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
                ('queue', models.BooleanField(default=False)),
                ('realtime', models.BooleanField(default=False)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubtaskType',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Tags',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=128)),
                ('description', models.CharField(max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='TaskBlueprint',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('specifications_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schedulings for this task (IMMUTABLE).')),
                ('do_cancel', models.BooleanField(help_text='Cancel this task.')),
                ('output_pinned', models.BooleanField(default=False, help_text='True if the output of this task is pinned to disk, that is, forbidden to be removed.')),
            ],
        ),
        migrations.CreateModel(
            name='TaskConnectorType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TaskDraft',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('specifications_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Specifications for this task.')),
                ('output_pinned', models.BooleanField(default=False, help_text='True if the output of this task is pinned to disk, that is, forbidden to be removed.')),
            ],
            bases=(models.Model, lofar.sas.tmss.tmss.tmssapp.models.specification.ProjectPropertyMixin),
        ),
        migrations.CreateModel(
            name='TaskRelationBlueprint',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('selection_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Filter for selecting dataproducts from the output role.')),
            ],
        ),
        migrations.CreateModel(
            name='TaskRelationDraft',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('selection_doc', django.contrib.postgres.fields.jsonb.JSONField(help_text='Filter for selecting dataproducts from the output role.')),
            ],
        ),
        migrations.CreateModel(
            name='TaskRelationSelectionTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TaskType',
            fields=[
                ('value', models.CharField(max_length=128, primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Setting',
            fields=[
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, primary_key=True, serialize=False, to='tmssapp.Flag', unique=True)),
                ('value', models.BooleanField()),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TaskTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('name', models.CharField(help_text='Human-readable name of this object.', max_length=128)),
                ('description', models.CharField(blank=True, default='', help_text='A longer description of this object.', max_length=255)),
                ('version', models.IntegerField(editable=False, help_text='Version of this template (with respect to other templates of the same name)')),
                ('schema', django.contrib.postgres.fields.jsonb.JSONField(help_text='Schema for the configurable parameters needed to use this template.')),
                ('validation_code_js', models.CharField(blank=True, default='', help_text='JavaScript code for additional (complex) validation.', max_length=128)),
                ('type', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.TaskType')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TaskSchedulingRelationDraft',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('time_offset', models.IntegerField(default=60, help_text='Time offset of start of second task with respect to start of first task.')),
                ('first', models.ForeignKey(help_text='First Task Draft to connect.', on_delete=django.db.models.deletion.CASCADE, related_name='first_scheduling_relation', to='tmssapp.TaskDraft')),
                ('placement', models.ForeignKey(help_text='Task scheduling relation placement.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingRelationPlacement')),
                ('second', models.ForeignKey(help_text='Second Task Draft to connect.', on_delete=django.db.models.deletion.CASCADE, related_name='second_scheduling_relation', to='tmssapp.TaskDraft')),
            ],
        ),
        migrations.CreateModel(
            name='TaskSchedulingRelationBlueprint',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tags', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=128), blank=True, default=list, help_text='User-defined search keywords for object.', size=8)),
                ('created_at', models.DateTimeField(auto_now_add=True, help_text='Moment of object creation.')),
                ('updated_at', models.DateTimeField(auto_now=True, help_text='Moment of last object update.')),
                ('time_offset', models.IntegerField(default=60, help_text='Time offset of start of second task with respect to start of first task.')),
                ('first', models.ForeignKey(help_text='First Task Blueprint to connect.', on_delete=django.db.models.deletion.CASCADE, related_name='first_scheduling_relation', to='tmssapp.TaskBlueprint')),
                ('placement', models.ForeignKey(default='after', help_text='Task scheduling relation placement.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingRelationPlacement')),
                ('second', models.ForeignKey(help_text='Second Task Blueprint to connect.', on_delete=django.db.models.deletion.CASCADE, related_name='second_scheduling_relation', to='tmssapp.TaskBlueprint')),
            ],
        ),
        migrations.CreateModel(
            name='StationTimeline',
            fields=[
                ('station_name', models.CharField(max_length=16, null=False, editable=False, help_text='The LOFAR station name.')),
                ('timestamp', models.DateField(editable=False, null=True, help_text='The date (YYYYMMDD).')),
                ('sunrise_start', models.DateTimeField(null=True, help_text='Start time of the sunrise.')),
                ('sunrise_end', models.DateTimeField(null=True, help_text='End time of the sunrise.')),
                ('sunset_start', models.DateTimeField(null=True, help_text='Start time of the sunset.')),
                ('sunset_end', models.DateTimeField(null=True, help_text='End time of the sunset.')),
            ],
        ),
        migrations.AddConstraint(
            model_name='taskrelationselectiontemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='taskrelationselectiontemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='taskrelationdraft',
            name='consumer',
            field=models.ForeignKey(help_text='Task Draft that has the input connector.', on_delete=django.db.models.deletion.CASCADE, related_name='produced_by', to='tmssapp.TaskDraft'),
        ),
        migrations.AddField(
            model_name='taskrelationdraft',
            name='dataformat',
            field=models.ForeignKey(help_text='Selected data format to use. One of (MS, HDF5).', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Dataformat'),
        ),
        migrations.AddField(
            model_name='taskrelationdraft',
            name='input_role',
            field=models.ForeignKey(help_text='Input connector type (what kind of data is given to the consumer).', on_delete=django.db.models.deletion.CASCADE, related_name='taskrelationdraft_input_roles', to='tmssapp.TaskConnectorType'),
        ),
        migrations.AddField(
            model_name='taskrelationdraft',
            name='output_role',
            field=models.ForeignKey(help_text='Output connector type (what kind of data is taken from the producer).', on_delete=django.db.models.deletion.CASCADE, related_name='taskrelationdraft_output_roles', to='tmssapp.TaskConnectorType'),
        ),
        migrations.AddField(
            model_name='taskrelationdraft',
            name='producer',
            field=models.ForeignKey(help_text='Task Draft that has the output connector. NOTE: The producer does typically, but not necessarily, belong to the same Scheduling Unit (or even the same Project) as the consumer.', on_delete=django.db.models.deletion.CASCADE, related_name='consumed_by', to='tmssapp.TaskDraft'),
        ),
        migrations.AddField(
            model_name='taskrelationdraft',
            name='selection_template',
            field=models.ForeignKey(help_text='Schema used for selection_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.TaskRelationSelectionTemplate'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='consumer',
            field=models.ForeignKey(help_text='Task Blueprint that has the input connector.', on_delete=django.db.models.deletion.CASCADE, related_name='produced_by', to='tmssapp.TaskBlueprint'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='dataformat',
            field=models.ForeignKey(help_text='Selected data format to use.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Dataformat'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='draft',
            field=models.ForeignKey(help_text='Task Relation Draft which this work request instantiates.', on_delete=django.db.models.deletion.CASCADE, related_name='related_task_relation_blueprint', to='tmssapp.TaskRelationDraft'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='input_role',
            field=models.ForeignKey(help_text='Input connector type (what kind of data can be taken as input).', on_delete=django.db.models.deletion.CASCADE, related_name='taskrelationblueprint_input_roles', to='tmssapp.TaskConnectorType'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='output_role',
            field=models.ForeignKey(help_text='Output connector type (what kind of data can be created as output).', on_delete=django.db.models.deletion.CASCADE, related_name='taskrelationblueprint_output_roles', to='tmssapp.TaskConnectorType'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='producer',
            field=models.ForeignKey(help_text='Task Blueprint that has the output connector.', on_delete=django.db.models.deletion.CASCADE, related_name='consumed_by', to='tmssapp.TaskBlueprint'),
        ),
        migrations.AddField(
            model_name='taskrelationblueprint',
            name='selection_template',
            field=models.ForeignKey(help_text='Schema used for selection_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.TaskRelationSelectionTemplate'),
        ),
        migrations.AddField(
            model_name='taskdraft',
            name='copies',
            field=models.ForeignKey(help_text='Source reference, if we are a copy (NULLable).', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='copied_from', to='tmssapp.TaskDraft'),
        ),
        migrations.AddField(
            model_name='taskdraft',
            name='copy_reason',
            field=models.ForeignKey(help_text='Reason why source was copied (NULLable).', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.CopyReason'),
        ),
        migrations.AddField(
            model_name='taskdraft',
            name='scheduling_unit_draft',
            field=models.ForeignKey(help_text='Scheduling Unit draft to which this task draft belongs.', on_delete=django.db.models.deletion.CASCADE, related_name='task_drafts', to='tmssapp.SchedulingUnitDraft'),
        ),
        migrations.AddField(
            model_name='taskdraft',
            name='specifications_template',
            field=models.ForeignKey(help_text='Schema used for requirements_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.TaskTemplate'),
        ),
        migrations.AddField(
            model_name='taskconnectortype',
            name='dataformats',
            field=models.ManyToManyField(blank=True, to='tmssapp.Dataformat'),
        ),
        migrations.AddField(
            model_name='taskconnectortype',
            name='datatype',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Datatype'),
        ),
        migrations.AddField(
            model_name='taskconnectortype',
            name='iotype',
            field=models.ForeignKey(help_text='Is this connector an input or output', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.IOType'),
        ),
        migrations.AddField(
            model_name='taskconnectortype',
            name='role',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Role'),
        ),
        migrations.AddField(
            model_name='taskconnectortype',
            name='task_template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='output_connector_types', to='tmssapp.TaskTemplate'),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='draft',
            field=models.ForeignKey(help_text='Task Draft which this task instantiates.', on_delete=django.db.models.deletion.PROTECT, related_name='task_blueprints', to='tmssapp.TaskDraft'),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='scheduling_unit_blueprint',
            field=models.ForeignKey(help_text='Scheduling Unit Blueprint to which this task belongs.', on_delete=django.db.models.deletion.CASCADE, related_name='task_blueprints', to='tmssapp.SchedulingUnitBlueprint'),
        ),
        migrations.AddField(
            model_name='taskblueprint',
            name='specifications_template',
            field=models.ForeignKey(help_text='Schema used for specifications_doc (IMMUTABLE).', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.TaskTemplate'),
        ),
        migrations.AddField(
            model_name='subtasktemplate',
            name='type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SubtaskType'),
        ),
        migrations.AddField(
            model_name='subtaskstatelog',
            name='new_state',
            field=models.ForeignKey(editable=False, help_text='Subtask state after update (see Subtask State Machine).', on_delete=django.db.models.deletion.PROTECT, related_name='is_new_state_of', to='tmssapp.SubtaskState'),
        ),
        migrations.AddField(
            model_name='subtaskstatelog',
            name='old_state',
            field=models.ForeignKey(editable=False, help_text='Subtask state before update (see Subtask State Machine).', null=True, on_delete=django.db.models.deletion.PROTECT, related_name='is_old_state_of', to='tmssapp.SubtaskState'),
        ),
        migrations.AddField(
            model_name='subtaskstatelog',
            name='subtask',
            field=models.ForeignKey(editable=False, help_text='Subtask to which this state change refers.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.Subtask'),
        ),
        migrations.AddField(
            model_name='subtaskstatelog',
            name='user',
            field=models.ForeignKey(editable=False, help_text='The user who changed the state of the subtask.', null=True, on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='subtaskoutput',
            name='subtask',
            field=models.ForeignKey(help_text='Subtask to which this output specification refers.', on_delete=django.db.models.deletion.CASCADE, related_name='outputs', to='tmssapp.Subtask'),
        ),
        migrations.AddField(
            model_name='subtaskinput',
            name='dataproducts',
            field=models.ManyToManyField(help_text='The Dataproducts resulting from application of the filter at time of scheduling Although the dataproducts are simply the result of applying the filter on immutable data, the filter application could change over time. We thus store the result of this filtering directly to retain which input was specified for the task..', to='tmssapp.Dataproduct'),
        ),
        migrations.AddField(
            model_name='subtaskinput',
            name='producer',
            field=models.ForeignKey(help_text='The SubtaskOutput producing the input dataproducts for this SubtaskInput.', on_delete=django.db.models.deletion.PROTECT, related_name='consumers', to='tmssapp.SubtaskOutput'),
        ),
        migrations.AddField(
            model_name='subtaskinput',
            name='selection_template',
            field=models.ForeignKey(help_text='Schema used for selection_doc.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.TaskRelationSelectionTemplate'),
        ),
        migrations.AddField(
            model_name='subtaskinput',
            name='subtask',
            field=models.ForeignKey(help_text='Subtask to which this input specification refers.', on_delete=django.db.models.deletion.CASCADE, related_name='inputs', to='tmssapp.Subtask'),
        ),
        migrations.AddField(
            model_name='subtaskinput',
            name='task_relation_blueprint',
            field=models.ForeignKey(help_text='Task Relation Blueprint which this Subtask Input implements (NULLable).', null=True, on_delete=django.db.models.deletion.SET_NULL, to='tmssapp.TaskRelationBlueprint'),
        ),
        migrations.AddField(
            model_name='subtask',
            name='cluster',
            field=models.ForeignKey(help_text='Where the Subtask is scheduled to run (NULLable).', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Cluster'),
        ),
        migrations.AddField(
            model_name='subtask',
            name='created_or_updated_by_user',
            field=models.ForeignKey(editable=False, help_text='The user who created / updated the subtask.', null=True, on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='subtask',
            name='global_identifier',
            field=models.OneToOneField(editable=False, help_text='The global unique identifier for LTA SIP.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SIPidentifier'),
        ),
        migrations.AddField(
            model_name='subtask',
            name='specifications_template',
            field=models.ForeignKey(help_text='Schema used for specifications_doc.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SubtaskTemplate'),
        ),
        migrations.AddField(
            model_name='subtask',
            name='state',
            field=models.ForeignKey(help_text='Subtask state (see Subtask State Machine).', on_delete=django.db.models.deletion.PROTECT, related_name='task_states', to='tmssapp.SubtaskState'),
        ),
        migrations.AddField(
            model_name='subtask',
            name='task_blueprint',
            field=models.ForeignKey(help_text='Task Blueprint to which this Subtask belongs.', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='subtasks', to='tmssapp.TaskBlueprint'),
        ),
        migrations.AddConstraint(
            model_name='stationtimeline',
            constraint=models.UniqueConstraint(fields=('station_name', 'timestamp'),  name='unique_station_time_line'),
        ),
        migrations.AddConstraint(
            model_name='schedulingunittemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='schedulingunittemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='schedulingunitobservingstrategytemplate',
            name='scheduling_unit_template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingUnitTemplate'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='copies',
            field=models.ForeignKey(help_text='Source reference, if we are a copy (NULLable).', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='copied_from', to='tmssapp.SchedulingUnitDraft'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='copy_reason',
            field=models.ForeignKey(help_text='Reason why source was copied (NULLable).', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.CopyReason'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='observation_strategy_template',
            field=models.ForeignKey(help_text='Observation Strategy Template used to create the requirements_doc.', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingUnitObservingStrategyTemplate'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='requirements_template',
            field=models.ForeignKey(help_text='Schema used for requirements_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.SchedulingUnitTemplate'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='scheduling_constraints_template',
            field=models.ForeignKey(help_text='Schema used for scheduling_constraints_doc.', null=True, on_delete=django.db.models.deletion.CASCADE, to='tmssapp.SchedulingConstraintsTemplate'),
        ),
        migrations.AddField(
            model_name='schedulingunitdraft',
            name='scheduling_set',
            field=models.ForeignKey(help_text='Set to which this scheduling unit draft belongs.', on_delete=django.db.models.deletion.CASCADE, related_name='scheduling_unit_drafts', to='tmssapp.SchedulingSet'),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='draft',
            field=models.ForeignKey(help_text='Scheduling Unit Draft which this run instantiates.', on_delete=django.db.models.deletion.PROTECT, related_name='scheduling_unit_blueprints', to='tmssapp.SchedulingUnitDraft'),
        ),
        migrations.AddField(
            model_name='schedulingunitblueprint',
            name='requirements_template',
            field=models.ForeignKey(help_text='Schema used for requirements_doc (IMMUTABLE).', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.SchedulingUnitTemplate'),
        ),
        migrations.AddField(
            model_name='schedulingset',
            name='generator_source',
            field=models.ForeignKey(help_text='Reference for the generator to an existing collection of specifications (NULLable).', null=True, on_delete=django.db.models.deletion.SET_NULL, to='tmssapp.SchedulingUnitDraft'),
        ),
        migrations.AddField(
            model_name='schedulingset',
            name='generator_template',
            field=models.ForeignKey(help_text='Generator for the scheduling units in this set (NULLable).', null=True, on_delete=django.db.models.deletion.SET_NULL, to='tmssapp.GeneratorTemplate'),
        ),
        migrations.AddField(
            model_name='schedulingset',
            name='project',
            field=models.ForeignKey(help_text='Project to which this scheduling set belongs.', on_delete=django.db.models.deletion.PROTECT, related_name='scheduling_sets', to='tmssapp.Project'),
        ),
        migrations.AddConstraint(
            model_name='schedulingconstraintstemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='schedulingconstraintstemplate_unique_name_version'),
        ),
        migrations.AddConstraint(
            model_name='saptemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='saptemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='sap',
            name='global_identifier',
            field=models.OneToOneField(editable=False, help_text='The global unique identifier for LTA SIP.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SIPidentifier'),
        ),
        migrations.AddField(
            model_name='sap',
            name='specifications_template',
            field=models.ForeignKey(help_text='Schema used for specifications_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.SAPTemplate'),
        ),
        migrations.AddField(
            model_name='resourcetype',
            name='quantity',
            field=models.ForeignKey(help_text='The quantity of this resource type.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Quantity'),
        ),
        migrations.AddConstraint(
            model_name='reservationtemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='reservationtemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='reservationstrategytemplate',
            name='reservation_template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.ReservationTemplate'),
        ),
        migrations.AddField(
            model_name='reservation',
            name='project',
            field=models.ForeignKey(help_text='Reservation will be accounted for this project.', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='reservations', to='tmssapp.Project'),
        ),
        migrations.AddField(
            model_name='reservation',
            name='specifications_template',
            field=models.ForeignKey(help_text='Schema used for specifications_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.ReservationTemplate'),
        ),
        migrations.AddField(
            model_name='projectquotaarchivelocation',
            name='archive_location',
            field=models.ForeignKey(help_text='Location of an archive LTA cluster.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Filesystem'),
        ),
        migrations.AddField(
            model_name='projectquotaarchivelocation',
            name='project_quota',
            field=models.ForeignKey(help_text='The ProjectQuota for this archive location', on_delete=django.db.models.deletion.PROTECT, related_name='project_quota_archive_location', to='tmssapp.ProjectQuota'),
        ),
        migrations.AddField(
            model_name='projectquota',
            name='project',
            field=models.ForeignKey(help_text='Project to wich this quota belongs.', on_delete=django.db.models.deletion.PROTECT, related_name='quota', to='tmssapp.Project'),
        ),
        migrations.AddField(
            model_name='projectquota',
            name='resource_type',
            field=models.ForeignKey(help_text='Resource type.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.ResourceType'),
        ),
        migrations.AddField(
            model_name='projectpermission',
            name='DELETE',
            field=models.ManyToManyField(blank=True, related_name='can_DELETE', to='tmssapp.ProjectRole'),
        ),
        migrations.AddField(
            model_name='projectpermission',
            name='GET',
            field=models.ManyToManyField(blank=True, related_name='can_GET', to='tmssapp.ProjectRole'),
        ),
        migrations.AddField(
            model_name='projectpermission',
            name='PATCH',
            field=models.ManyToManyField(blank=True, related_name='can_PATCH', to='tmssapp.ProjectRole'),
        ),
        migrations.AddField(
            model_name='projectpermission',
            name='POST',
            field=models.ManyToManyField(blank=True, related_name='can_POST', to='tmssapp.ProjectRole'),
        ),
        migrations.AddField(
            model_name='projectpermission',
            name='PUT',
            field=models.ManyToManyField(blank=True, related_name='can_PUT', to='tmssapp.ProjectRole'),
        ),
        migrations.AddField(
            model_name='project',
            name='cycles',
            field=models.ManyToManyField(blank=True, help_text='Cycles to which this project belongs (NULLable).', related_name='projects', to='tmssapp.Cycle'),
        ),
        migrations.AddField(
            model_name='project',
            name='period_category',
            field=models.ForeignKey(help_text='Period category.', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.PeriodCategory'),
        ),
        migrations.AddField(
            model_name='project',
            name='project_category',
            field=models.ForeignKey(help_text='Project category.', null=True, on_delete=django.db.models.deletion.PROTECT, to='tmssapp.ProjectCategory'),
        ),
        migrations.AddConstraint(
            model_name='generatortemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='generatortemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='filesystem',
            name='cluster',
            field=models.ForeignKey(help_text='Cluster hosting this filesystem.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Cluster'),
        ),
        migrations.AddField(
            model_name='defaulttasktemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.TaskTemplate'),
        ),
        migrations.AddField(
            model_name='defaulttaskrelationselectiontemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.TaskRelationSelectionTemplate'),
        ),
        migrations.AddField(
            model_name='defaultsubtasktemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SubtaskTemplate'),
        ),
        migrations.AddField(
            model_name='defaultschedulingunittemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingUnitTemplate'),
        ),
        migrations.AddField(
            model_name='defaultschedulingconstraintstemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SchedulingConstraintsTemplate'),
        ),
        migrations.AddField(
            model_name='defaultreservationtemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.ReservationTemplate'),
        ),
        migrations.AddField(
            model_name='defaultgeneratortemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.GeneratorTemplate'),
        ),
        migrations.AddField(
            model_name='defaultdataproductspecificationstemplate',
            name='template',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.DataproductSpecificationsTemplate'),
        ),
        migrations.AddField(
            model_name='dataproducttransform',
            name='input',
            field=models.ForeignKey(help_text='A dataproduct that was the input of a transformation.', on_delete=django.db.models.deletion.PROTECT, related_name='consumers', to='tmssapp.Dataproduct'),
        ),
        migrations.AddField(
            model_name='dataproducttransform',
            name='output',
            field=models.ForeignKey(help_text='A dataproduct that was produced from the input dataproduct.', on_delete=django.db.models.deletion.PROTECT, related_name='producers', to='tmssapp.Dataproduct'),
        ),
        migrations.AddConstraint(
            model_name='dataproductspecificationstemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='dataproductspecificationstemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='dataproducthash',
            name='algorithm',
            field=models.ForeignKey(help_text='Algorithm used (MD5, AES256).', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Algorithm'),
        ),
        migrations.AddField(
            model_name='dataproducthash',
            name='dataproduct',
            field=models.ForeignKey(help_text='The dataproduct to which this hash refers.', on_delete=django.db.models.deletion.PROTECT, related_name='hashes', to='tmssapp.Dataproduct'),
        ),
        migrations.AddConstraint(
            model_name='dataproductfeedbacktemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='dataproductfeedbacktemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='dataproductarchiveinfo',
            name='dataproduct',
            field=models.OneToOneField(help_text='A dataproduct residing in the archive.', on_delete=django.db.models.deletion.PROTECT, related_name='archive_info', to='tmssapp.Dataproduct'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='dataformat',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Dataformat'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='datatype',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.Datatype'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='feedback_template',
            field=models.ForeignKey(help_text='Schema used for feedback_doc.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.DataproductFeedbackTemplate'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='global_identifier',
            field=models.OneToOneField(editable=False, help_text='The global unique identifier for LTA SIP.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.SIPidentifier'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='producer',
            field=models.ForeignKey(help_text='Subtask Output which generates this dataproduct.', on_delete=django.db.models.deletion.PROTECT, related_name='dataproducts', to='tmssapp.SubtaskOutput'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='sap',
            field=models.ForeignKey(help_text='SAP this dataproduct was generated out of (NULLable).', null=True, on_delete=django.db.models.deletion.PROTECT, related_name='dataproducts', to='tmssapp.SAP'),
        ),
        migrations.AddField(
            model_name='dataproduct',
            name='specifications_template',
            field=models.ForeignKey(help_text='Schema used for specifications_doc.', on_delete=django.db.models.deletion.CASCADE, to='tmssapp.DataproductSpecificationsTemplate'),
        ),
        migrations.AddField(
            model_name='cyclequota',
            name='cycle',
            field=models.ForeignKey(help_text='Cycle to which these quota apply.', on_delete=django.db.models.deletion.PROTECT, related_name='quota', to='tmssapp.Cycle'),
        ),
        migrations.AddField(
            model_name='cyclequota',
            name='resource_type',
            field=models.ForeignKey(help_text='Resource type.', on_delete=django.db.models.deletion.PROTECT, to='tmssapp.ResourceType'),
        ),
        migrations.AddConstraint(
            model_name='commonschematemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='commonschematemplate_unique_name_version'),
        ),
        migrations.AddField(
            model_name='antennaset',
            name='station_type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='tmssapp.StationType'),
        ),
        migrations.AddConstraint(
            model_name='tasktemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='tasktemplate_unique_name_version'),
        ),
        migrations.AddConstraint(
            model_name='taskschedulingrelationdraft',
            constraint=models.UniqueConstraint(fields=('first', 'second'), name='TaskSchedulingRelationDraft_unique_relation'),
        ),
        migrations.AddConstraint(
            model_name='taskschedulingrelationblueprint',
            constraint=models.UniqueConstraint(fields=('first', 'second'), name='TaskSchedulingRelationBlueprint_unique_relation'),
        ),
        migrations.AddConstraint(
            model_name='taskrelationdraft',
            constraint=models.UniqueConstraint(fields=('producer', 'consumer', 'input_role', 'output_role'), name='TaskRelationDraft_unique_relation'),
        ),
        migrations.AddConstraint(
            model_name='taskrelationblueprint',
            constraint=models.UniqueConstraint(fields=('producer', 'consumer', 'input_role', 'output_role'), name='TaskRelationBlueprint_unique_relation'),
        ),
        migrations.AddConstraint(
            model_name='taskdraft',
            constraint=models.UniqueConstraint(fields=('name', 'scheduling_unit_draft'), name='TaskDraft_unique_name_in_scheduling_unit'),
        ),
        migrations.AddIndex(
            model_name='taskconnectortype',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_tas_tags_19ff09_gin'),
        ),
        migrations.AddConstraint(
            model_name='taskblueprint',
            constraint=models.UniqueConstraint(fields=('name', 'scheduling_unit_blueprint'), name='TaskBlueprint_unique_name_in_scheduling_unit'),
        ),
        migrations.AddConstraint(
            model_name='subtasktemplate',
            constraint=models.UniqueConstraint(fields=('name', 'version'), name='subtasktemplate_unique_name_version'),
        ),
        migrations.AddIndex(
            model_name='subtaskstatelog',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_sub_tags_70e4a2_gin'),
        ),
        migrations.AddIndex(
            model_name='subtaskoutput',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_sub_tags_e25b4c_gin'),
        ),
        migrations.AddIndex(
            model_name='subtaskinput',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_sub_tags_fb9960_gin'),
        ),
        migrations.AddIndex(
            model_name='subtask',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_sub_tags_d2fc43_gin'),
        ),
        migrations.AddIndex(
            model_name='setting',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_set_tags_41a1ba_gin'),
        ),
        migrations.AddIndex(
            model_name='sap',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_sap_tags_7451b0_gin'),
        ),
        migrations.AddIndex(
            model_name='defaulttasktemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_c88200_gin'),
        ),
        migrations.AddIndex(
            model_name='defaulttaskrelationselectiontemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_3bee7d_gin'),
        ),
        migrations.AddIndex(
            model_name='defaultsubtasktemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_e9c73d_gin'),
        ),
        migrations.AddIndex(
            model_name='defaultschedulingunittemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_3ab2d6_gin'),
        ),
        migrations.AddIndex(
            model_name='defaultschedulingconstraintstemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_480bbd_gin'),
        ),
        migrations.AddIndex(
            model_name='defaultreservationtemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_58d7a4_gin'),
        ),
        migrations.AddIndex(
            model_name='defaultgeneratortemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_89c89d_gin'),
        ),
        migrations.AddIndex(
            model_name='defaultdataproductspecificationstemplate',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_def_tags_269b1f_gin'),
        ),
        migrations.AddIndex(
            model_name='dataproducttransform',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_dat_tags_380c1f_gin'),
        ),
        migrations.AddIndex(
            model_name='dataproducthash',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_dat_tags_dae145_gin'),
        ),
        migrations.AddIndex(
            model_name='dataproductarchiveinfo',
            index=django.contrib.postgres.indexes.GinIndex(fields=['tags'], name='tmssapp_dat_tags_ebf2ef_gin'),
        ),
        migrations.AddConstraint(
            model_name='dataproduct',
            constraint=models.UniqueConstraint(fields=('directory', 'filename'), name='dataproduct_unique_path'),
        ),
    ]
