from lofar.sas.tmss.tmss.tmssapp import models


def get_active_station_reservations_in_timewindow(lower_bound, upper_bound):
    """
    Retrieve a list of all active stations reservations, which are reserved between a timewindow
    """
    lst_active_station_reservations = []
    for res in models.Reservation.objects.filter(start_time__lt=upper_bound, stop_time__gt=lower_bound).values('specifications_doc'):
        lst_active_station_reservations += res["specifications_doc"]["resources"]["stations"]
    for res in models.Reservation.objects.filter(start_time__lt=upper_bound, stop_time=None).values('specifications_doc'):
        lst_active_station_reservations += res["specifications_doc"]["resources"]["stations"]
    return list(set(lst_active_station_reservations))
